class CodeFormatter
  def self.call(*args)
    new(*args).call
  end

  def initialize(maker_code = [], user_code = [])
    @maker_code = maker_code
    @user_code = user_code
  end

  def call
    format(@maker_code, @user_code)
  end

  def format(maker_code, user_code)
    user_code.each_with_index.map do |char, index|
      if maker_code[index] == user_code[index]
        maker_code[index] = nil
        '+'
      else
        char_index = maker_code.index(char)
        if char_index && minus?(char_index, maker_code, user_code)
          maker_code[char_index] = nil
          '-'
        end
      end
    end.compact.sort
  end

  private

  def minus?(char_index, maker_code, user_code)
    return unless maker_code[char_index]

    maker_code[char_index] != user_code[char_index]
  end
end
